// 003 u_c_gadget_factory
// 19 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_gadget_factory;
  interface
    uses u_c_basic_object
        , u_c_control
        , u_c_square_controls
        , u_c_round_controls
        , u_c_gadget
        , u_c_gadget_implementation
        ;

    const k_button_default_height= 20;

    type // -- definitions only for the Virtual Abstract functions in the factory
         c_abstract_gadget_factory= class(c_basic_object)
                                      m_c_control_list_ref: c_control_list;
                                      // -- required when create the gadgets
                                      // --  will be initialized within the f_c_create_gadget_implementation
                                      _m_c_abstract_gadget_implementation_ref: c_abstract_gadget_implementation;

                                      Constructor create_abstract_gadget_factory(p_name: String;
                                          p_c_control_list_ref: c_control_list);

                                      function f_c_create_button_gadget(p_caption: String;
                                          p_left, p_top, p_width, p_height: Integer;
                                          p_on_click: t_on_click): c_button_gadget; Virtual; Abstract;
                                      function f_c_create_label_gadget(p_caption: String;
                                          p_left, p_top, p_width, p_height: Integer): c_label_gadget; Virtual; Abstract;
                                      function f_c_create_draw_surface_gadget(p_caption: String;
                                          p_left, p_top, p_width, p_height: Integer;
                                          p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down): c_draw_surface_gadget; Virtual; Abstract;
                                      function f_c_create_scrollbar_gadget(p_caption: String;
                                          p_left, p_top, p_width, p_height: Integer): c_scrollbar_gadget; Virtual; Abstract;

                                      function f_c_create_gadget_implementation(p_name: String): c_abstract_gadget_implementation; Virtual; Abstract;

                                      procedure create_lexi(p_left, p_top, p_width, p_height: Integer);
                                    end; // c_abstract_gadget_factory

         // -- the width height square gadgets

         c_square_button_gadget= Class(c_button_gadget)
                                   m_c_square_button_control: c_square_button_control;
                                   Constructor create_square_button_gadget(p_name: String;
                                       p_c_abstract_gadget_factory: c_abstract_gadget_factory;
                                       p_left, p_top, p_width, p_height: Integer;
                                       p_on_click: t_on_click);
                                 end; // c_square_button_gadget
         c_square_label_gadget= Class(c_label_gadget)
                                  m_c_square_label_control: c_square_label_control;
                                  Constructor create_square_label_gadget(p_name: String;
                                      p_c_abstract_gadget_factory: c_abstract_gadget_factory;
                                      p_left, p_top, p_width, p_height: Integer);
                                end; // c_square_label_gadget
         c_square_draw_surface_gadget= Class(c_draw_surface_gadget)
                                         m_c_square_draw_surface_control: c_square_draw_surface_control;
                                         Constructor create_square_draw_surface_gadget(p_name: String;
                                             p_c_abstract_gadget_factory: c_abstract_gadget_factory;
                                             p_left, p_top, p_width, p_height: Integer;
                                             p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down);
                                       end; // c_square_draw_surface_gadget
         c_square_scrollbar_gadget= Class(c_scrollbar_gadget)
                                       m_c_square_scrollbar_control: c_square_scrollbar_control;
                                       Constructor create_square_scrollbar_gadget(p_name: String;
                                           p_c_abstract_gadget_factory: c_abstract_gadget_factory;
                                           p_left, p_top, p_width, p_height: Integer);
                                     end; // c_square_scrollbar_gadget
         c_square_gadget_factory= class(c_abstract_gadget_factory)
                                    Constructor create_square_gadget_factory(p_name: String;
                                        p_c_control_list_ref: c_control_list);

                                    function f_c_create_button_gadget(p_caption: String;
                                        p_left, p_top, p_width, p_height: Integer;
                                        p_on_click: t_on_click): c_button_gadget; Override;
                                    function f_c_create_label_gadget(p_caption: String;
                                        p_left, p_top, p_width, p_height: Integer): c_label_gadget; Override;
                                    function f_c_create_draw_surface_gadget(p_caption: String;
                                        p_left, p_top, p_width, p_height: Integer;
                                        p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down): c_draw_surface_gadget; Override;
                                    function f_c_create_scrollbar_gadget(p_caption: String;
                                        p_left, p_top, p_width, p_height: Integer): c_scrollbar_gadget; Override;

                                    function f_c_create_gadget_implementation(p_name: String): c_abstract_gadget_implementation; Override;
                                  end; // c_abstract_factory

         // -- the 2 points round gadgets

         c_round_button_gadget= Class(c_button_gadget)
                                  m_c_round_button_control: c_round_button_control;
                                  Constructor create_round_button_gadget(p_name: String;
                                      p_c_abstract_gadget_factory: c_abstract_gadget_factory;
                                      p_left, p_top, p_width, p_height: Integer;
                                      p_on_click: t_on_click);
                                end; // c_round_button_gadget
         c_round_label_gadget= Class(c_label_gadget)
                                  m_c_round_label_control: c_round_label_control;
                                  Constructor create_round_label_gadget(p_name: String;
                                      p_c_abstract_gadget_factory: c_abstract_gadget_factory;
                                      p_left, p_top, p_width, p_height: Integer);
                               end; // c_round_label_gadget
         c_round_draw_surface_gadget= Class(c_draw_surface_gadget)
                                        m_c_round_draw_surface_control: c_round_draw_surface_control;
                                        Constructor create_round_draw_surface_gadget(p_name: String;
                                            p_c_abstract_gadget_factory: c_abstract_gadget_factory;
                                            p_left, p_top, p_width, p_height: Integer;
                                            p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down);
                                      end; // c_round_draw_surface_gadget

         c_round_scrollbar_gadget= Class(c_scrollbar_gadget)
                                     m_c_round_scrollbar_control: c_round_scrollbar_control;
                                     Constructor create_round_scrollbar_gadget(p_name: String;
                                         p_c_abstract_gadget_factory: c_abstract_gadget_factory;
                                         p_left, p_top, p_width, p_height: Integer);
                                   end; // c_round_scrollbar_gadget
         c_round_gadget_factory= class(c_abstract_gadget_factory)
                                  Constructor create_round_gadget_factory(p_name: String;
                                      p_c_control_list_ref: c_control_list);

                                  function f_c_create_button_gadget(p_caption: String;
                                      p_left, p_top, p_width, p_height: Integer;
                                      p_on_click: t_on_click): c_button_gadget; Override;
                                  function f_c_create_label_gadget(p_caption: String;
                                      p_left, p_top, p_width, p_height: Integer): c_label_gadget; Override;
                                  function f_c_create_draw_surface_gadget(p_caption: String;
                                      p_left, p_top, p_width, p_height: Integer;
                                      p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down): c_draw_surface_gadget; Override;
                                  function f_c_create_scrollbar_gadget(p_caption: String;
                                      p_left, p_top, p_width, p_height: Integer): c_scrollbar_gadget; Override;

                                  function f_c_create_gadget_implementation(p_name: String): c_abstract_gadget_implementation; Override;
                               end; // c_abstract_factory

  implementation
    uses SysUtils
        , u_c_display
        ;

    // -- c_abstract_gadget_factory

    Constructor c_abstract_gadget_factory.create_abstract_gadget_factory(p_name: String;
        p_c_control_list_ref: c_control_list);
        // -- used to add the c_control_list_ref
      begin
        Inherited create_basic_object(p_name);
        m_c_control_list_ref:= p_c_control_list_ref;
      end; // create_abstract_gadget_factory

    procedure c_abstract_gadget_factory.create_lexi(p_left, p_top, p_width, p_height: Integer);
        // -- here creates several gadget
      var l_height_fraction: Integer;
      begin
        l_height_fraction:= p_height div 5;
        f_c_create_button_gadget('button_1', p_left+ 4, l_height_fraction,
            p_width- 8, l_height_fraction, Nil);
        f_c_create_button_gadget('button_2', p_left+ 4, 3* l_height_fraction,
            p_width- 8, l_height_fraction, Nil);
      end; // create_lexi

    // -- c_square_button

    Constructor c_square_button_gadget.create_square_button_gadget(p_name: String;
        p_c_abstract_gadget_factory: c_abstract_gadget_factory;
        p_left, p_top, p_width, p_height: Integer;
        p_on_click: t_on_click);
      begin
        Inherited create_button_gadget(p_name,
            p_c_abstract_gadget_factory._m_c_abstract_gadget_implementation_ref, p_left, p_top, p_width, p_height);

        // -- this creates the button AND attaches it to the control list
        m_c_square_button_control:= c_square_button_control.create_square_button_control(p_name,
            p_c_abstract_gadget_factory.m_c_control_list_ref,
            p_left, p_top, p_left+ p_width, p_top+ p_height,
            p_on_click);
      end; // create_square_button_gadget

   // -- c_square_label_gadget

   Constructor c_square_label_gadget.create_square_label_gadget(p_name: String;
       p_c_abstract_gadget_factory: c_abstract_gadget_factory;
       p_left, p_top, p_width, p_height: Integer);
     begin
        // -- this is for drawing on the label
        Inherited create_label_gadget(p_name,
            p_c_abstract_gadget_factory._m_c_abstract_gadget_implementation_ref, p_left, p_top, p_width, p_height);

        // -- this is for the "windowing library"
        m_c_square_label_control:= c_square_label_control.create_square_label_control(p_name,
            p_c_abstract_gadget_factory.m_c_control_list_ref,
            p_left, p_top, p_left+ p_width, p_top+ p_height);
     end; // c_square_label_gadget

    // -- c_square_draw_surface_gadget

    Constructor c_square_draw_surface_gadget.create_square_draw_surface_gadget(p_name: String;
        p_c_abstract_gadget_factory: c_abstract_gadget_factory;
        p_left, p_top, p_width, p_height: Integer;
        p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down);
      begin
        Inherited create_draw_surface_gadget(p_name,
            p_c_abstract_gadget_factory._m_c_abstract_gadget_implementation_ref, p_left, p_top, p_width, p_height);

        m_c_square_draw_surface_control:= c_square_draw_surface_control.create_square_draw_surface_control(p_name,
            p_c_abstract_gadget_factory.m_c_control_list_ref,
            p_left, p_top, p_left+ p_width, p_top+ p_height,
            p_on_mouse_down, p_on_mouse_move, p_on_mouse_up);
      end; // create_square_draw_surface_gadget

   // -- c_square_scrollbar_gadget

   Constructor c_square_scrollbar_gadget.create_square_scrollbar_gadget(p_name: String;
       p_c_abstract_gadget_factory: c_abstract_gadget_factory;
       p_left, p_top, p_width, p_height: Integer);
     begin
        Inherited create_scrollbar_gadget(p_name,
            p_c_abstract_gadget_factory._m_c_abstract_gadget_implementation_ref, p_left, p_top, p_width, p_height);

        m_c_square_scrollbar_control:= c_square_scrollbar_control.create_square_scrollbar_control(p_name,
            p_c_abstract_gadget_factory.m_c_control_list_ref,
            p_left, p_top, p_left+ p_width, p_top+ p_height);
     end; // c_square_scrollbar_gadget

    // -- c_square_gadget_factory

    Constructor c_square_gadget_factory.create_square_gadget_factory(p_name: String;
        p_c_control_list_ref: c_control_list);
      begin
        Inherited create_abstract_gadget_factory(p_name, p_c_control_list_ref);
      end; // create_square_gadget_factory

    function c_square_gadget_factory.f_c_create_button_gadget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer;
        p_on_click: t_on_click): c_button_gadget;
      begin
        Result:= c_square_button_gadget.create_square_button_gadget(p_caption, Self,
            p_left, p_top, p_width, p_height, p_on_click);
      end; // f_c_create_button_gadget

    function c_square_gadget_factory.f_c_create_label_gadget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer): c_label_gadget;
      begin
        Result:= c_square_label_gadget.create_square_label_gadget(p_caption, Self,
            p_left, p_top, p_width, p_height);
      end; // f_c_create_label_gadget

    function c_square_gadget_factory.f_c_create_draw_surface_gadget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer;
        p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down): c_draw_surface_gadget;
      begin
        Result:= c_square_draw_surface_gadget.create_square_draw_surface_gadget(p_caption, Self,
            p_left, p_top, p_width, p_height,
            p_on_mouse_down, p_on_mouse_move, p_on_mouse_up);
      end; // f_c_create_draw_surface_gadget

    function c_square_gadget_factory.f_c_create_scrollbar_gadget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer): c_scrollbar_gadget;
      begin
        Result:= c_square_scrollbar_gadget.create_square_scrollbar_gadget(p_caption, Self,
            p_left, p_top, p_width, p_height);
      end; // f_c_create_scrollbar_gadget

    function c_square_gadget_factory.f_c_create_gadget_implementation(p_name: String): c_abstract_gadget_implementation;
      begin
        display('sqare');
        Result:= c_square_gadget_implementation.create_square_gadget_implementation(p_name,
           m_c_control_list_ref);
        // -- prepare the creation of gadgets
        _m_c_abstract_gadget_implementation_ref:= Result;
      end; // f_c_create_gadget_implementation

    // -- c_round_button_gadget

    Constructor c_round_button_gadget.create_round_button_gadget(p_name: String;
        p_c_abstract_gadget_factory: c_abstract_gadget_factory;
        p_left, p_top, p_width, p_height: Integer;
        p_on_click: t_on_click);
      begin
        Inherited create_button_gadget(p_name,
            p_c_abstract_gadget_factory._m_c_abstract_gadget_implementation_ref, p_left, p_top, p_width, p_height);

        // -- here adapts the parameter to the 2P world
        m_c_round_button_control:= c_round_button_control.create_round_button_control(p_name,
            p_c_abstract_gadget_factory.m_c_control_list_ref,
            p_left, p_top, p_width, p_height / p_width,
            p_on_click);
      end; // create_round_button_gadget

    // -- c_round_label_gadget

    Constructor c_round_label_gadget.create_round_label_gadget(p_name: String;
        p_c_abstract_gadget_factory: c_abstract_gadget_factory;
        p_left, p_top, p_width, p_height: Integer);
      begin
        Inherited create_label_gadget(p_name,
            p_c_abstract_gadget_factory._m_c_abstract_gadget_implementation_ref, p_left, p_top, p_width, p_height);

        // -- here adapts the parameter to the 2P world
        m_c_round_label_control:= c_round_label_control.create_round_label_control(p_name,
            p_c_abstract_gadget_factory.m_c_control_list_ref,
            p_left, p_top, p_width, p_height / p_width);
      end; // create_round_label_gadget

    // -- c_round_draw_surface_gadget

    Constructor c_round_draw_surface_gadget.create_round_draw_surface_gadget(p_name: String;
        p_c_abstract_gadget_factory: c_abstract_gadget_factory;
        p_left, p_top, p_width, p_height: Integer;
        p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down);
      begin
        Inherited create_draw_surface_gadget(p_name,
            p_c_abstract_gadget_factory._m_c_abstract_gadget_implementation_ref, p_left, p_top, p_width, p_height);

        // -- here adapts the parameter to the 2P world
        m_c_round_draw_surface_control:= c_round_draw_surface_control.create_round_draw_surface_control(p_name,
            p_c_abstract_gadget_factory.m_c_control_list_ref,
            p_left, p_top, p_width, p_height / p_width,
            p_on_mouse_down, p_on_mouse_move, p_on_mouse_up)
      end; // create_round_draw_surface_gadget

   // -- c_round_scrollbar_gadget

   Constructor c_round_scrollbar_gadget.create_round_scrollbar_gadget(p_name: String;
       p_c_abstract_gadget_factory: c_abstract_gadget_factory;
       p_left, p_top, p_width, p_height: Integer);
     begin
        Inherited create_scrollbar_gadget(p_name,
            p_c_abstract_gadget_factory._m_c_abstract_gadget_implementation_ref, p_left, p_top, p_width, p_height);

        m_c_round_scrollbar_control:= c_round_scrollbar_control.create_round_scrollbar_control(p_name,
            p_c_abstract_gadget_factory.m_c_control_list_ref,
            p_left, p_top, p_width, p_height / p_width);
     end; // c_round_scrollbar_gadget

    // -- c_round_gadget_factory

    Constructor c_round_gadget_factory.create_round_gadget_factory(p_name: String;
        p_c_control_list_ref: c_control_list);
      begin
        Inherited create_abstract_gadget_factory(p_name, p_c_control_list_ref);
      end; // create_round_gadget_factory

    function c_round_gadget_factory.f_c_create_button_gadget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer;
        p_on_click: t_on_click): c_button_gadget;
      begin
        Result:= c_round_button_gadget.create_round_button_gadget(p_caption, Self,
            p_left, p_top, p_width, p_height, p_on_click);
      end; // f_c_create_button_gadget

    function c_round_gadget_factory.f_c_create_label_gadget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer): c_label_gadget;
      begin
        Result:= c_round_label_gadget.create_round_label_gadget(p_caption, Self,
            p_left, p_top, p_width, p_height);
      end; // f_c_create_button_gadget

    function c_round_gadget_factory.f_c_create_draw_surface_gadget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer;
        p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down): c_draw_surface_gadget;
      begin
        Result:= c_round_draw_surface_gadget.create_round_draw_surface_gadget(p_caption, Self,
            p_left, p_top, p_width, p_height,
            p_on_mouse_down, p_on_mouse_move, p_on_mouse_up);
      end; // f_c_create_draw_surface_gadget

    function c_round_gadget_factory.f_c_create_scrollbar_gadget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer): c_scrollbar_gadget;
      begin
        Result:= c_round_scrollbar_gadget.create_round_scrollbar_gadget(p_caption, Self,
            p_left, p_top, p_width, p_height);
      end; // f_c_create_scrollbar_gadget

    function c_round_gadget_factory.f_c_create_gadget_implementation(p_name: String): c_abstract_gadget_implementation;
      begin
        Result:= c_round_gadget_implementation.create_round_gadget_implementation(p_name,
           m_c_control_list_ref);
        // -- prepare the creation of gadgets
        _m_c_abstract_gadget_implementation_ref:= Result;
      end; // f_c_create_gadget_implementation

    begin // u_c_abstract_factory
    end. // u_c_abstract_factory
